#pragma once

#include <pspuser.h>

#define MSB_VersionDate "20111016"
#define MSB_VersionFull "MSB Ver." MSB_VersionDate " by Moonlight."
#define MSB_VersionFull_UpperCase "MSB VER." MSB_VersionDate " BY MOONLIGHT."

#define Resources_FontPath "Resources_Fonts"
#define Resources_SystemPath "Resources_System"
#define Resources_FileListPath "Resources_FileList"
#define Resources_ImageViewPath "Resources_ImageView"
#define Resources_TextReaderPath "Resources_TextReader"

#define CWL() printf("%s:%d.\n",__FILE__,__LINE__)

extern void SystemHalt(void);

#define ScreenLineSize (512)
#define ScreenWidth (480)
#define ScreenHeight (272)

typedef struct {
  u32 Buttons; // ::PspCtrlButtons
  s32 anax,anay;
} TKeys;

enum EProcState {EPS_Loop,EPS_FileList,EPS_ImageView,EPS_TextReader};
extern EProcState ProcStateNext;

typedef struct {
  void (*Start)(EProcState ProcStateLast);
  void (*End)(void);
  void (*KeyDown)(u32 keys,u32 VSyncCount);
  void (*KeyUp)(u32 keys,u32 VSyncCount);
  void (*KeyPress)(u32 keys,u32 VSyncCount);
  void (*KeysUpdate)(TKeys *pk,u32 VSyncCount);
  void (*UpdateGU)(u32 VSyncCount);
  void (*LibSndEnd)(void);
} TProc_Interface;

static void SetProcStateNext(EProcState ProcState)
{
  ProcStateNext=ProcState;
}

extern char Proc_ImageView_ImageFilename[256];
extern char Proc_TextReader_TextFilename[256];

extern volatile u32 VBlankPassedCount;

